import javax.media.j3d.*;
import javax.vecmath.*;

public class Crystal extends Shape3D
{
	/*   ---   萔   ---   */

	private final static Point3f[] vertexs={		// _
		new Point3f( 0.2f, 0.0f, 0.0f),new Point3f( 0.0f, 0.0f, 0.2f),
		new Point3f( 0.0f,-0.5f, 0.0f),			// 1
		new Point3f( 0.0f, 0.0f, 0.2f),new Point3f(-0.2f, 0.0f, 0.0f),
		new Point3f( 0.0f,-0.5f, 0.0f),			// 2
		new Point3f(-0.2f, 0.0f, 0.0f),new Point3f( 0.0f, 0.0f,-0.2f),
		new Point3f( 0.0f,-0.5f, 0.0f),			// 3
		new Point3f( 0.0f, 0.0f,-0.2f),new Point3f( 0.2f, 0.0f, 0.0f),
		new Point3f( 0.0f,-0.5f, 0.0f),			// 4
		new Point3f( 0.0f, 0.0f, 0.2f),new Point3f( 0.2f, 0.0f, 0.0f),
		new Point3f( 0.0f, 0.5f, 0.0f),			// 5
		new Point3f(-0.2f, 0.0f, 0.0f),new Point3f( 0.0f, 0.0f, 0.2f),
		new Point3f( 0.0f, 0.5f, 0.0f),			// 6
		new Point3f( 0.0f, 0.0f,-0.2f),new Point3f(-0.2f, 0.0f, 0.0f),
		new Point3f( 0.0f, 0.5f, 0.0f),			// 7
		new Point3f( 0.2f, 0.0f, 0.0f),new Point3f( 0.0f, 0.0f,-0.2f),
		new Point3f( 0.0f, 0.5f, 0.0f)};		// 8
	private final static Vector3f[] normals={		// @
		new Vector3f( 0.2f,-0.5f, 0.2f),new Vector3f( 0.2f,-0.5f, 0.2f),
		new Vector3f( 0.2f,-0.5f, 0.2f),		// 1
		new Vector3f(-0.2f,-0.5f, 0.2f),new Vector3f(-0.2f,-0.5f, 0.2f),
		new Vector3f(-0.2f,-0.5f, 0.2f),		// 2
		new Vector3f(-0.2f,-0.5f,-0.2f),new Vector3f(-0.2f,-0.5f,-0.2f),
		new Vector3f(-0.2f,-0.5f,-0.2f),		// 3
		new Vector3f( 0.2f,-0.5f,-0.2f),new Vector3f( 0.2f,-0.5f,-0.2f),
		new Vector3f( 0.2f,-0.5f,-0.2f),		// 4
		new Vector3f( 0.2f, 0.5f, 0.2f),new Vector3f( 0.2f, 0.5f, 0.2f),
		new Vector3f( 0.2f, 0.5f, 0.2f),		// 5
		new Vector3f(-0.2f, 0.5f, 0.2f),new Vector3f(-0.2f, 0.5f, 0.2f),
		new Vector3f(-0.2f, 0.5f, 0.2f),		// 6
		new Vector3f(-0.2f, 0.5f,-0.2f),new Vector3f(-0.2f, 0.5f,-0.2f),
		new Vector3f(-0.2f, 0.5f,-0.2f),		// 7
		new Vector3f( 0.2f, 0.5f,-0.2f),new Vector3f( 0.2f, 0.5f,-0.2f),
		new Vector3f( 0.2f, 0.5f,-0.2f)};		// 8

	/*   ---   Constructor   ---   */

	public Crystal()
	{
		super(createGeometry());
	}

	public Crystal(Appearance appearance)
	{
		super(createGeometry(),appearance);
	}

	/*   ---      ---   */

	private static Geometry createGeometry()
	{
		TriangleArray geometry;
	
		geometry=new TriangleArray(24,
		             TriangleArray.COORDINATES | TriangleArray.NORMALS);
		// 24   = 3 (Op`)~8 () = _ 
		// TriangleArray.COORDINATES = _w肷
		// TriangleArray.NORMAL      = @w肷
		
		geometry.setCoordinates(0,vertexs);	// _ݒ
		geometry.setNormals(0,normals);		// @ݒ
		
		return geometry;
	}
}
