import java.applet.Applet;
import java.awt.BorderLayout;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.Cylinder;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.universe.*;

public class Tunnel extends Applet
{
	/*   ---   Field   ---   */

	private Canvas3D canvas;
	private SimpleUniverse universe;

	/*   ---      ---   */

	public void init()
	{
		canvas=new Canvas3D(null);
		universe=new SimpleUniverse(canvas);
		
		universe.getViewingPlatform().setNominalViewingTransform();
		universe.addBranchGraph(createSceneGraph());
		
		setLayout(new BorderLayout());
		add(canvas,BorderLayout.CENTER);
	}

	private BranchGroup createSceneGraph()
	{
		BranchGroup root;
	
		root=new BranchGroup();
		root.addChild(createLight());
		root.addChild(createTunnel());
		root.addChild(createBall());
		root.addChild(createCrystal());
		
		return root;
	}

	private Node createLight()						// ̐ݒ
	{
		Light light;
		BoundingSphere bounds;
	
		light=new PointLight(new Color3f(10.0f,10.0f,10.0f),
		                     new Point3f( 0.3f, 0.3f,10.0f),
		                     new Point3f( 0.1f, 0.1f, 0.0f));
		// (0.3,0.3,10.0) ̈ʒuɂ R=10.0,G=10.0,B=10.0 ̖邳̓_
		
		bounds=new BoundingSphere(new Point3d(),
		                          Double.POSITIVE_INFINITY);
		light.setInfluencingBounds(bounds);
		// L͈͖͂
		
		return light;
	}

	private Node createTunnel()						// gl̐ݒ
	{
		Transform3D rotation;
		TransformGroup transform;
		Appearance appearance;
		Texture texture;
		Material material;
		Cylinder tunnel;
	
		rotation=new Transform3D();
		rotation.rotX(Math.PI/2.0+Math.PI/180.0*5.0);
		transform=new TransformGroup(rotation);		// x ŉ]
		
		appearance=new Appearance();
		
		texture=new TextureLoader("tunnel.jpg",this).getTexture();
		appearance.setTexture(texture);				// eNX`\
		
		material=new Material();
		material.setLightingEnable(true);
		appearance.setMaterial(material);			// ̔ˋ̐ݒ
		
		tunnel=new Cylinder(1.0f,100.0f,Cylinder.GENERATE_NORMALS |
		                                Cylinder.GENERATE_NORMALS_INWARD |
		                                Cylinder.GENERATE_TEXTURE_COORDS,
		                                300,100,appearance);
		transform.addChild(tunnel);
		// a 1.0A 100.0 ̉~ (ɖ@ݒ)
		
		return transform;
	}

	private Node createBall()						// {[̐ݒ
	{
		Transform3D translation;
		TransformGroup transform;
		Appearance appearance;
		Material material;
		Sphere ball;
	
		translation=new Transform3D();
		translation.setTranslation(new Vector3d(0.4,0.4,-1.0));
		transform=new TransformGroup(translation);			// sړ
		
		appearance=new Appearance();
		
		material=new Material();
		material.setDiffuseColor(0.01f,0.10f,0.02f);
		material.setSpecularColor(0.01f,0.10f,0.02f);
		material.setLightingEnable(true);
		appearance.setMaterial(material);			// ̔ˋݒ
		
		ball=new Sphere(0.5f,Sphere.GENERATE_NORMALS,appearance);
		transform.addChild(ball);
		// a 0.5 ̋
		
		return transform;
	}

	private Node createCrystal()					// ̐ݒ
	{
		Transform3D translation,rotation;
		TransformGroup transform1,transform2;
		Appearance appearance;
		Material material;
		TransparencyAttributes transparent;
		Crystal crystal;
	
		translation=new Transform3D();
		translation.setTranslation(new Vector3d(-0.3,-0.4,-0.5));
		transform1=new TransformGroup(translation);			// sړ
		
		rotation=new Transform3D();
		rotation.rotZ(Math.PI/180.0*30.0);
		transform2=new TransformGroup(rotation);
		transform1.addChild(transform2);			// Z ŉ]
		
		appearance=new Appearance();
		
		material=new Material();
		material.setDiffuseColor(0.30f,0.01f,0.02f);
		material.setSpecularColor(0.90f,0.01f,0.09f);
		material.setShininess(1250);
		material.setLightingEnable(true);
		appearance.setMaterial(material);			// ̔ˋݒ
		
		transparent=new TransparencyAttributes(
		                TransparencyAttributes.BLENDED,0.5f);
		appearance.setTransparencyAttributes(transparent);
		// x 0.5
		
		crystal=new Crystal(appearance);
		transform2.addChild(crystal);
		// ` (Xg3)
		
		return transform1;
	}
}
